Description

When using the following code in modern Ruby, it starts to fail:

validate_presence :setting, if: ->(settings) { false }

 This causes the if: part to be interpreted as a setting to validate, rather than as a predicate for :setting.

I reproduced this on Smart Proxy 3.2.0-develop with Ruby 3. It looks like there's no test coverage for this use case.

Associated revisions

Revision 01b39acd - 01/04/2022 01:38 PM - Ewoud Kohl van Wijngaarden

Fixes #34141 - Make validators modern Ruby compatible

In old Ruby versions a hash was pushed as the last argument but in

modern Ruby there is first class support for this via kwargs. This

worked if a single argument was provided but if they were combined it

failed:

validate_presence :setting, if: ->(settings) { false }

 This then tried to create a validator of a hash rather than as a

predicate. It then also unconditionally validates :setting.

History

#1 - 12/13/2021 03:32 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/smart-proxy/pull/806 added

#2 - 01/04/2022 01:38 PM - The Foreman Bot

- Fixed in Releases 3.2.0 added

#3 - 01/04/2022 02:01 PM - Ewoud Kohl van Wijngaarden

- Status changed from Ready For Testing to Closed

Applied in changeset 01b39acde45a27d0b25912c2e0d449f772a59745.

#4 - 05/26/2022 10:00 AM - Amit Upadhye

- Subject changed from validate_presence and validate_readable with predicate broken to The validate_presence and validate_readable with

predicate broken
